
#include <device.h>
char testbuffer[1000];							// 

#define TRUE  1
#define FALSE 0

uint8 UART_Busy(void);
void GetText(char *buffer, int time); 


uint16 n=0;

//*************************************************************************************************************************

int main()
{
UART_Start(); UART_T_Start(); 
LCD_Char_Start(); 
CyGlobalIntEnable; 		
//--------------------------------
while(1)
 { 
//----------  GetData -----------
	UART_SpiUartClearRxBuffer();
	memset(testbuffer,0,1000);
	UART_T_PutString("123456789");   
// 	CyDelayUs(300);									// see only  12345  for 300uS
 	while(UART_Busy())  {   CyDelayUs(0);	};		//  stop at    15 < n <500      if no  CyDelayUs(0);
	GetText(testbuffer, 1);
	LCD_Char_Position(0,0); LCD_Char_PrintString(testbuffer);  
	LCD_Char_Position(1,0); LCD_Char_PrintNumber(n);  
	n++;
	CyDelay(100);
 }

}
//*********************    end ************************************************************


//-----------------------------------------------------------------
//                   When is an UART busy  (Bob Marlowe)
//  http://www.cypress.com/?app=forum&id=2233&rID=56771
//---------------------------------------------------------------------------------------
uint8 UART_Busy(void)
{
uint8 STS;
static uint8 FirstTimeCalled = TRUE;
#define Busy 1 							// Just for better readabiliy (I hope)
	
STS = UART_T_ReadTxStatus(); 
if (!((UART_T_GetTxBufferSize() == 0) && (STS & UART_T_TX_STS_FIFO_EMPTY))) // Are the UART buffers empty?
	{
	FirstTimeCalled = FALSE;
	return Busy; 						// Buffers NOT empty, return "Busy"
	}
else 									// UART buffers empty, but last byte may be transfered currently
	{
	if (STS & UART_T_TX_STS_COMPLETE) 	// Is Transfer completed? Bit was reset with call to UART_ReadTxStatus()
	  {
		FirstTimeCalled = TRUE; 		// Yes, we are done
		return !Busy;
	  }
	else 								// Transfer not completed or called the first time after a !Busy returned
	  {
		if (FirstTimeCalled) return !Busy; 
		return Busy;
	  }
    }
#undef Busy
}//..........................................



void GetText(char *buffer, int time) 
{
int i=0;
 do{
	buffer[i] = UART_UartGetChar();							// add the next byte of data in the buffer
	if( !buffer[i])   {CyDelay(1); time--;}					// data over? - Wait ...
	i++;        Test_Write(1);Test_Write(0);				// increment the pointer and test impulse
	}while(time);											// waiting time limit ?
buffer[i] = 0;												// finish buffer zero then there is no need to clean it)
} //.........................	
